<?php
/**
 * @fileID: $Id: product_type.php 7820 2012-02-16 05:45:06Z alfiya $
 * @changedDate: $LastChangedDate: 2012-02-16 12:45:06 +0700 (Thu, 16 Feb 2012) $
 * @changedBy: $LastChangedBy: alfiya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsProduct_type extends JPlugin
{
	function plgJoomsuite_content_fieldsProduct_type( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'product_type') return;
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];
		if($type = $params->get('product_type'))
		{
			$dispatcher =& JDispatcher::getInstance();
			JPluginHelper::importPlugin('joomsuite_product_type',$type);
			$plugin =& JPluginHelper::getPlugin('joomsuite_product_type', $type);
			$pluginParams = new JParameter( $plugin->params );


			$ptval = $this->getFieldExtraValue($type, $obj->id, $obj->record_id);
				
			if(isset($ptval->value) && $ptval->value != '')
			{
				$ptvals = ($type == 'htmltype') ? array($ptval->value) : explode("\n", $ptval->value);
				foreach($ptvals as $val)
				{
					if($type == 'htmltype')
					$vals = array('htmltype', substr($val, 5));
					else
					$vals = explode("=", $val);
					if($vals[0])
					$obj->$vals[0] = (isset($vals[1])) ? $vals[1] : '';
				}
				$obj->field_value_id = $ptval->fvid;
			}

			$dispatcher->trigger('onRenderField', array (&$obj, &$params, $type));


		}

		?>
<input
	type="hidden" name="fields[<?php echo $obj->id?>][name]"
	value="<?php echo $type; ?>" />
		<?php

	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'product_type') return;

		if(!$value) return;

		$db = &JFactory::getDBO();
		$type_value = $value;
		$value = $value['name'];
		$ptypes = JRequest::getVar('pparams');

		if($type_value['downloadable'])
		{
			if($params->get('type') == 1)
			{
				$dispatcher =& JDispatcher::getInstance();
				$fields = JRequest::getVar('fields');
				$download_id = array_search($value, $fields);
				//$name = (isset($_FILES['files']['name'][$id])) ? $_FILES['files']['name'][$id] : $ptypes['file-'.$id];
				if( isset($type_value['files']) && $name = $type_value['files'][0] )
				{
					JPluginHelper::importPlugin('joomsuite_product_type', $value);
					$plugin =& JPluginHelper::getPlugin('joomsuite_product_type', $value);
					$pluginParams = new JParameter( $plugin->params );
					$params->set('suffix', '_'.time());
					$return  = $dispatcher->trigger('onBeforeSave', array (&$value, &$params, $value, $id, $row, &$error));
					$sess = JFactory::getSession();
					
					//$ptypes = array($id => array('file-'.$id => $name));
					if($params->get('attach'))
					{
						foreach ($return as $k => $val)
						{
							if($val != '')
							{
								$name = basename($val);
							}
						}
					//	$ext = JString::strtolower(JFile::getExt( $name ));
					//	$name = JFile::stripExt( $name ).$params->get('suffix').'.'.$ext;
					}
					$ptypes = array($id => array('file-'.$id => $name));
				}
				else
				{
					if($old = $ptypes[$id]['file-'.$id])
					{
						jimport('joomla.filesystem.file');
						jimport('joomla.filesystem.folder');
						$path = JPATH_ROOT.DS.$params->get('directory').DS.'product_type'.DS.$row->user_id;
						JFile::delete($path.DS.$old);
							
						$ptypes[$id] = array('file-'.$id => '');
					}
				}
			}

		}
		$tmp = array();
		if(isset($ptypes[$id]))
		{
			foreach($ptypes[$id] as $k=>$val)
			{
				/*if($value != 'download' && $value != 'tangible' && $value != 'pincode')// && $val == '')
				 break;*/
				if($type_value['downloadable'] && $params->get('type') == 2 && $val == -1) continue;
				if($value != 'htmltype')
				$val = str_replace("\n", "|", $val);

				if(is_array($val)) $val = implode(",", $val);
				$tmp[]= "$k=$val";
			}
		}
		if(count($tmp) > 0 )
		{
			$ptval = implode("\n", $tmp);
			$sql = "SELECT id FROM #__js_res_field_extra WHERE field_id = '$id' AND record_id = '{$row->id}'";
			$db->setQuery($sql);
			$file_uniq = JRequest::getVar('file_unique');
			$query = '';
			if($type_value['downloadable'])
			{
				$query = ", field_value_id = '".($file_uniq[$id]? 1 : 0 )."'";
			}
			if($res = $db->loadResultArray())
			{
				$sql = "UPDATE #__js_res_field_extra SET value='$ptval', ref_id='$value'
				".$query."
				WHERE id='".$res[0]."'"; 
				$db->setQuery($sql);
				$db->query();
			}
			else
			{
				$sql = "INSERT INTO #__js_res_field_extra  SET user_id = '{$row->user_id}',
				ref_id = '{$value}', ctime = NOW(), value = '{$ptval}', field_id = '$id', record_id = '{$row->id}'".$query;
				$db->setQuery($sql);
				$db->query();

			}

			$value = $db->getEscaped(trim($value));
			if($type_value['downloadable']) { $value = $val; }
		}
		else $value = "";
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'product_type') return;
		if(!$field->field_value) return;
		
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		$db = &JFactory::getDBO();
		$sql = "SELECT * FROM #__js_res_field_extra WHERE field_id = '{$field->fid}' AND record_id = '{$field->record_id}'";
		$db->setQuery($sql);
		$res = $db->loadObject();
		$res->title = $field->title;
		$res->type = $res->ref_id;
		$res->params = $field->params;
		$dispatcher =& JDispatcher::getInstance();
		JPluginHelper::importPlugin('joomsuite_product_type', $res->ref_id);
		$plugin =& JPluginHelper::getPlugin('joomsuite_product_type', $res->ref_id);
		$pluginParams = new JParameter( $plugin->params );
		$dispatcher->trigger('onRenderFieldValue', array (&$out, &$res, &$record, $category));
	}
	
	function getFieldExtraValue($type, $fid, $rid)
	{
		$db = & Jfactory::getDBO();
		$sql = "SELECT value, field_value_id as fvid FROM #__js_res_field_extra
		WHERE ref_id = '$type' AND field_id = '$fid' AND record_id = '$rid'";
		$db->setQuery($sql);
		return $db->loadObject();
	}
}
?>